<?php
/**
 * TorrentTrader Lite v2.0.1 
 *  - Coded by Sqrtboy 
 *  - Released under the GPL licence
 *  - Contact/Support/Hacks/Discussion @ http://www.phpsoft.org
 **/

  ob_start('ob_gzhandler');

  require_once('config.php');
  require_once("functions.php");

  if (!isset($language))
  $language="english.lang";

  require_once("languages/".$language);

  $pubDate = date("D, d M Y H:i:s");
  $Feed = '
  <rss version="2.0" xmlns:bittorrent="http://www.borget.info/bittorrent-rss/" >
    <channel>
        <title>'.$sitetitle.' RSS Feed</title>
    <link>'.$siteurl.'</link>
    <description>'.RSS_POWERED_BY.$version.'</description>
    <language>'.$sitelang.'</language><pubDate>'.$pubDate.'</pubDate>';

  $source = fopen('data/torrents.dat','r');
  flock($source, LOCK_EX) ;
  $cnt = 0;
  while ($info = fscanf ($source, "%s %s %s %d %d %s %s %d %d %d %d\n")) {
  list ($info_hash, $filename, $name,$size,$numfiles,$descr,$category,$seeders,$leechers,$completed,$hits) = $info;
  $cnt ++;
  if ($cnt > $feed_max) break;
  $Feed .= '
  <item>
    <title>'.htmlentities($name).'</title>
    <category>'.$category.'</category>
    <description>'.htmlentities($descr).'</description>
	<link>'.$siteurl.'</link>
    <guid>'.$siteurl.'/details.php?info_hash='.$info_hash.'</guid>
    <enclosure url="'.$siteurl.'/download.php?info_hash='.$info_hash.'" length="'.$size.'" type="application/x-bittorrent" />
	<pubDate>'.$pubDate.'</pubDate>
	<bittorrent:info_hash>'.$info_hash.'</bittorrent:info_hash>
	<bittorrent:seeders>'.$seeders.'</bittorrent:seeders>
	<bittorrent:leechers>'.$leechers.'</bittorrent:leechers>
	<bittorrent:completed>'.$completed.'</bittorrent:completed>
	<bittorrent:dht>dht://'. strtoupper($info_hash).'.dht</bittorrent:dht>
	<bittorrent:magnet>magnet:?xt=urn:btih:'. strtoupper(base32_encode(pack('H*',$info_hash))).'</bittorrent:magnet>					
  </item>';
  }

  flock($source, LOCK_UN);
  fclose($source);


  $Feed .= '</channel>
  </rss>';

  header("Content-type: text/xml");
  echo $Feed;
  die();
  ?>