<?php
/**
 * TorrentTrader Lite v2.0.1 
 *  - Coded by Sqrtboy 
 *  - Released under the GPL licence
 *  - Contact/Support/Hacks/Discussion @ http://www.phpsoft.org
 **/

// READ STATS FROM A GIVEN TORRENT
function getstat($hash) {
	global $time;
	
	if (!file_exists('data/'.$hash))
		touch('data/'.$hash);
		
	$handle = fopen('data/'.$hash, 'rb+');
	flock($handle, LOCK_EX);
	$length = filesize('data/'.$hash);
	
	if ($length)
	{
	
		$x = fread($handle, $length);
		$no_peers = $length / 19;
		
		$complete	= 0;
		$incomplete	= 0;
		
		$time = time() % 7680 / 60;	
		
		for ($j=0; $j<$no_peers; $j++)
		{
			$t_peer_seed = implode('', unpack('C', substr($x, $j * 19, 1)));
			
			if ($t_peer_seed >= 128)
			{
				$complete++;
				$t_time = $t_peer_seed - 128;
			}
			else
			{
				$incomplete++;
				$t_time = $t_peer_seed;	
			}
			
			// cleanup old peers
		
			if ($time - 40 <= $t_time and $time >= $t_time or $time + 88 < $t_time)
			{
				$new_data .= substr($x, $j * 19, 19);
			}
		}

	}
	else
	{
		$complete = 0;
		$incomplete = 0;
	}
	
	echo '20:'.pack('H*', $hash).'d8:completei'.$complete.'e10:incompletei'.$incomplete.'ee';
	
	
	rewind($handle);
	ftruncate($handle, 0);
	fwrite($handle, $new_data);
	flock($handle, LOCK_UN);
	fclose($handle);
}

$time = intval((time() % 7680) / 60);


// OUTPUT THE RESULT
ob_start('ob_gzhandler');	
			
header('Content-type: text/plain');


$scrapefile = 'scrape';


if (strpos($_SERVER["QUERY_STRING"], "info_hash=") === 0)
{
	// SINGE OR MULTI SCRAPE
	
	echo 'd5:filesd';
	
	// support for multiple scrape
	foreach (explode("&", $_SERVER["QUERY_STRING"]) as $item) 
	{ 
	
		if (substr($item, 0, 10) == "info_hash=") 
		{ 
		
			$info_hash = substr($item, 10);
			
			if (get_magic_quotes_gpc())
			{
				$info_hash = stripslashes($info_hash);
			}
			
			if (strlen($info_hash) == 20)
				$info_hash = bin2hex($info_hash);
			else if (strlen($info_hash) != 40)
				exit('d14:failure reason14:Invalid info_hashe');
			

			if (!file_exists('data/'.$info_hash.'.lock'))
				getstat($info_hash);
		}
	
	}
	

	
	echo 'ee';
}
else
{

	// GLOBAL SCRAPE
			
	
	if ( file_exists($scrapefile) && @filemtime($scrapefile) > (time() - 60))
	{
	
		// USE CACHE
		
		$handle = fopen($scrapefile, 'rb');
		flock($handle, LOCK_EX);
		echo fread($handle, filesize($scrapefile));		
		flock($handle, LOCK_UN);
		fclose($handle);

	}
	else
	{
		// GENERATE NEW CACHE
		
		
		echo 'd5:filesd';
		
		$handle = opendir('data');
		
		while (($file = readdir($handle)) !== false)
		{
			if ($file != '.' and $file != '..' and $file != '.htaccess' and $file != 'torrents.dat' and $file != 'index.php' and strpos($file, '.lock') === false and strlen($file) == 40 )
			{
				if (!file_exists('data/'.$file.'.lock'))
					getstat($file);
			}
		}
		
		closedir($handle);
		echo 'ee';
		

		$output = ob_get_contents();
		
		$handle = fopen($scrapefile, 'wb');
		flock($handle, LOCK_EX);
		fwrite($handle, $output);
		flock($handle, LOCK_UN);
		fclose($handle);
	}
}
?>