<?php
/**
 * TorrentTrader Lite v2.0.1 
 *  - Coded by Sqrtboy 
 *  - Released under the GPL licence
 *  - Contact/Support/Hacks/Discussion @ http://www.phpsoft.org
 **/

 
require_once('config.php');

function error($txt,$browser=false)
{
	global $siteurl;
	if ($browser == false)
		exit('d14:failure reason' . strlen($txt) . ':' . $txt . 'e');
	else exit('<br><br><center><b><font size=4></font></b><meta http-equiv="refresh" content="3;url='.$siteurl.'">');
}

// this page can be requested only by bittorrent clients !
$agent = $_SERVER["HTTP_USER_AGENT"];
if ( strpos($agent, "Mozilla") === 0 || strpos($agent, "Opera") === 0|| strpos($agent, "Links") === 0 || strpos($agent, "Lynx") === 0 || strpos($agent, "curl") === 0) 
	error("You are being redirect to main site, please wait !",true); 

if ($_GET['compact'] != 1)
{
	error('This tracker requires compact announce. Please update your client to the latest version.');
}

if (get_magic_quotes_gpc())
{
	$_GET['info_hash'] = stripslashes($_GET['info_hash']);
}

$_GET['info_hash'] = bin2hex($_GET['info_hash']);

if (strlen($_GET['info_hash']) != 40)
{
	error('Invalid info_hash submitted value');
}





$peer_ip = pack('Nn', ip2long($_SERVER['REMOTE_ADDR']), $_GET['port']);
$peer_details = pack('lll', $_GET['uploaded'],  $_GET['downloaded'],  $_GET['left']);

$time = time() % 7680 / 60;
$cur_time = $time;

if ($_GET['left'] == 0)
{
	$time += 128;
}


// we check if the torrent has been banned on tracker
if (file_exists('data/'.$_GET['info_hash'].'.lock'))
	err('This torrent has been banned from the tracker !');


$time = pack('C', $time);
$peers = array();
$updated = false;

if (!file_exists('data/'.$_GET['info_hash']))
{
	// we check that the torrent is authorized on the tracker
	$handle = fopen('data/torrents.dat', 'r');
	flock($handle, LOCK_EX);
	$allowed = fread($handle, filesize('data/torrents.dat'));
	flock($handle, LOCK_UN);
	fclose($handle);
	
	if (strpos($allowed, $_GET['info_hash']) === false)
	{
		error('This torrent is not authorized on this tracker.');
	}
		
	// create the data for this torrent	
	touch('data/'.$_GET['info_hash']);
	
	$handle = fopen('data/'.$_GET['info_hash'], 'wb');
	flock($handle, LOCK_EX);
	$peer_num = 0;
}
else
{
	$handle = fopen('data/'.$_GET['info_hash'], 'rb+');
	flock($handle, LOCK_EX);
	$length = filesize('data/'.$_GET['info_hash']);
	
	if ($length)
	{
		$peer_num = $length / 19;
		$data = fread($handle, $length);
		

	
		for ($i=0; $i<$peer_num; $i++)
		{

			
			
			if ($peer_ip == substr($data, $i * 19 + 1, 6))
			{
				$updated = true;
				
				if ($_GET['event'] == 'stopped')
				{
					$peer_num--;
				}
				else
				{
					$peers[] = $time.$peer_ip.$peer_details;
				}
			}
			else
			{
				$t_peer_seed = implode('', unpack('C', substr($data, $i * 19, 1)));	
					
				if ($t_peer_seed >= 128)
				{
					$t_time = $t_peer_seed - 128;
				}
				else
				{
					$t_time = $t_peer_seed;
				}
				

				$peers[] = substr($data, $i * 19, 19);

			}
		}
	}
}

if ($updated == false)
{
	$peers[] = $time.$peer_ip.$peer_details;
	$peer_num++;
}

rewind($handle);
ftruncate($handle, 0);
fwrite($handle, implode('', $peers), $peer_num * 19);
flock($handle, LOCK_UN);
fclose($handle);

// update the completed counter
if ($_GET['event'] == "completed")
{
	$source = fopen('data/torrents.dat','r+');
	flock($source, LOCK_EX) ;
	$content = '';
	while ($info = fscanf ($source, "%s %s %s %ld %d %s %s %d %d %d %d\n")) {
		list ($prev_info_hash, $filename, $name,$size,$numfiles,$descr,$category,$seeders,$leechers,$completed,$hits) = $info;
		 if ($_GET['info_hash'] ==  $prev_info_hash)
		 {
			$completed += 1;
		 }
		 $content .= sprintf("%s %s %s %ld %d %s %s %d %d %d %d\n",$prev_info_hash, $filename, $name,$size,$numfiles,$descr,$category,$seeders,$leechers,$completed,$hits);
	
	}


	// we update the data for this torrent
	rewind($source);
	ftruncate($source,0);
	fwrite($source, $content);
	flock($source, LOCK_UN);
	fclose($source);

}



// output the content
ob_start('ob_gzhandler');	

	

header('Content-Type: text/plain');
header('Pragma: no-cache');
    	


if ($peer_num <= 50)
	echo 'd8:intervali'.$announce_interval.'e5:peers', ($peer_num * 6), ':';
else echo 'd8:intervali'.$announce_interval.'e5:peers300:';

if ($_GET['event'] != 'stopped' or $_GET['numwant'] !== 0)
{
	if ($peer_num > 50)
	{
		$keys = array_rand($peers, 50);
		
		foreach($keys as $key)
		{
			echo substr($peers[$key], 1, 6);
		}
	}
	else
	{
		for($i=0; $i<$peer_num; $i++)
		{
			echo substr($peers[$i], 1, 6);
		}
	}
}

echo 'e';



?>